/* tslint:disable */
/* eslint-disable */
/**
 * AimsBackend
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface PredicateObject
 */
export interface PredicateObject {
    /**
     * 
     * @type {string}
     * @memberof PredicateObject
     */
    'predicate'?: string;
    /**
     * 
     * @type {string}
     * @memberof PredicateObject
     */
    'object'?: string;
}
/**
 * 
 * @export
 * @interface ProblemDetails
 */
export interface ProblemDetails {
    [key: string]: any;

    /**
     * 
     * @type {string}
     * @memberof ProblemDetails
     */
    'type'?: string | null;
    /**
     * 
     * @type {string}
     * @memberof ProblemDetails
     */
    'title'?: string | null;
    /**
     * 
     * @type {number}
     * @memberof ProblemDetails
     */
    'status'?: number | null;
    /**
     * 
     * @type {string}
     * @memberof ProblemDetails
     */
    'detail'?: string | null;
    /**
     * 
     * @type {string}
     * @memberof ProblemDetails
     */
    'instance'?: string | null;
}
/**
 * 
 * @export
 * @interface ValidationReturnObject
 */
export interface ValidationReturnObject {
    /**
     * 
     * @type {boolean}
     * @memberof ValidationReturnObject
     */
    'valid'?: boolean;
}

/**
 * MetadataApi - axios parameter creator
 * @export
 */
export const MetadataApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} [subject] 
         * @param {string} [predicate] 
         * @param {string} [query] 
         * @param {string} [targetClass] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGet: async (subject?: string, predicate?: string, query?: string, targetClass?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/Metadata`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (subject !== undefined) {
                localVarQueryParameter['subject'] = subject;
            }

            if (predicate !== undefined) {
                localVarQueryParameter['predicate'] = predicate;
            }

            if (query !== undefined) {
                localVarQueryParameter['query'] = query;
            }

            if (targetClass !== undefined) {
                localVarQueryParameter['targetClass'] = targetClass;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} body 
         * @param {string} [applicationProfile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataPost: async (body: string, applicationProfile?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'body' is not null or undefined
            assertParamExists('metadataPost', 'body', body)
            const localVarPath = `/Metadata`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (applicationProfile !== undefined) {
                localVarQueryParameter['applicationProfile'] = applicationProfile;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(body, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {Array<PredicateObject>} predicateObject 
         * @param {string} [subject] 
         * @param {string} [predicate] 
         * @param {string} [query] 
         * @param {string} [targetClass] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataPostAll: async (predicateObject: Array<PredicateObject>, subject?: string, predicate?: string, query?: string, targetClass?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'predicateObject' is not null or undefined
            assertParamExists('metadataPostAll', 'predicateObject', predicateObject)
            const localVarPath = `/query`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (subject !== undefined) {
                localVarQueryParameter['subject'] = subject;
            }

            if (predicate !== undefined) {
                localVarQueryParameter['predicate'] = predicate;
            }

            if (query !== undefined) {
                localVarQueryParameter['query'] = query;
            }

            if (targetClass !== undefined) {
                localVarQueryParameter['targetClass'] = targetClass;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(predicateObject, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} body 
         * @param {string} [applicationProfile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataValidate: async (body: string, applicationProfile?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'body' is not null or undefined
            assertParamExists('metadataValidate', 'body', body)
            const localVarPath = `/validate`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (applicationProfile !== undefined) {
                localVarQueryParameter['applicationProfile'] = applicationProfile;
            }


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(body, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * MetadataApi - functional programming interface
 * @export
 */
export const MetadataApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = MetadataApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {string} [subject] 
         * @param {string} [predicate] 
         * @param {string} [query] 
         * @param {string} [targetClass] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataGet(subject?: string, predicate?: string, query?: string, targetClass?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<string>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataGet(subject, predicate, query, targetClass, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {string} body 
         * @param {string} [applicationProfile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataPost(body: string, applicationProfile?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataPost(body, applicationProfile, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {Array<PredicateObject>} predicateObject 
         * @param {string} [subject] 
         * @param {string} [predicate] 
         * @param {string} [query] 
         * @param {string} [targetClass] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataPostAll(predicateObject: Array<PredicateObject>, subject?: string, predicate?: string, query?: string, targetClass?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<string>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataPostAll(predicateObject, subject, predicate, query, targetClass, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {string} body 
         * @param {string} [applicationProfile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataValidate(body: string, applicationProfile?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ValidationReturnObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataValidate(body, applicationProfile, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * MetadataApi - factory interface
 * @export
 */
export const MetadataApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = MetadataApiFp(configuration)
    return {
        /**
         * 
         * @param {string} [subject] 
         * @param {string} [predicate] 
         * @param {string} [query] 
         * @param {string} [targetClass] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGet(subject?: string, predicate?: string, query?: string, targetClass?: string, options?: any): AxiosPromise<Array<string>> {
            return localVarFp.metadataGet(subject, predicate, query, targetClass, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {string} body 
         * @param {string} [applicationProfile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataPost(body: string, applicationProfile?: string, options?: any): AxiosPromise<void> {
            return localVarFp.metadataPost(body, applicationProfile, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {Array<PredicateObject>} predicateObject 
         * @param {string} [subject] 
         * @param {string} [predicate] 
         * @param {string} [query] 
         * @param {string} [targetClass] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataPostAll(predicateObject: Array<PredicateObject>, subject?: string, predicate?: string, query?: string, targetClass?: string, options?: any): AxiosPromise<Array<string>> {
            return localVarFp.metadataPostAll(predicateObject, subject, predicate, query, targetClass, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {string} body 
         * @param {string} [applicationProfile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataValidate(body: string, applicationProfile?: string, options?: any): AxiosPromise<ValidationReturnObject> {
            return localVarFp.metadataValidate(body, applicationProfile, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * MetadataApi - object-oriented interface
 * @export
 * @class MetadataApi
 * @extends {BaseAPI}
 */
export class MetadataApi extends BaseAPI {
    /**
     * 
     * @param {string} [subject] 
     * @param {string} [predicate] 
     * @param {string} [query] 
     * @param {string} [targetClass] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataGet(subject?: string, predicate?: string, query?: string, targetClass?: string, options?: AxiosRequestConfig) {
        return MetadataApiFp(this.configuration).metadataGet(subject, predicate, query, targetClass, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {string} body 
     * @param {string} [applicationProfile] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataPost(body: string, applicationProfile?: string, options?: AxiosRequestConfig) {
        return MetadataApiFp(this.configuration).metadataPost(body, applicationProfile, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {Array<PredicateObject>} predicateObject 
     * @param {string} [subject] 
     * @param {string} [predicate] 
     * @param {string} [query] 
     * @param {string} [targetClass] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataPostAll(predicateObject: Array<PredicateObject>, subject?: string, predicate?: string, query?: string, targetClass?: string, options?: AxiosRequestConfig) {
        return MetadataApiFp(this.configuration).metadataPostAll(predicateObject, subject, predicate, query, targetClass, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {string} body 
     * @param {string} [applicationProfile] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataValidate(body: string, applicationProfile?: string, options?: AxiosRequestConfig) {
        return MetadataApiFp(this.configuration).metadataValidate(body, applicationProfile, options).then((request) => request(this.axios, this.basePath));
    }
}


